from modules.azure.model_config_base import ModelConfigBase


class ModelConfigG4Base(ModelConfigBase):
    ADDRESS = "address"
    PORT = "port"

    def get_address(self):
        return self._configs.get(ModelConfigG4Base.ADDRESS, "192.168.1.20")

    def get_port(self):
        return self._configs.get(ModelConfigG4Base.PORT, 1111)

    def _is_valid_conf_item(self, name, value):
        if name == ModelConfigG4Base.ADDRESS:
            if not isinstance(value, str):
                print("Error! the setting value of ", name, " is not string.")
                return False
            return True
        elif name == ModelConfigG4Base.PORT:
            if not isinstance(value, int):
                print("Error! the setting value of ", name, " is not integer.")
                return False
            return True
        else:
            return super()._is_valid_conf_item(name, value)

#
# End of File
#

