import os

from modules.azure.model_dev_base import ModelDevBase
from modules.azure.g4_basic_reporter import G4BasicReporter

class ModelDevG4Basic(ModelDevBase):
    def __init__(self, modelConfig):
        super().__init__(modelConfig, component_name=None)
        self._weightcode_reporter = None
        self._props["serialNumber"] = os.getenv("NUMBER")

    def model_id(self):
        return ""

    def _make_active_reporters(self, config, report_queue, report_repository):
        reporters = []
 
        g4basic_reporter = G4BasicReporter(report_queue,
                                           report_repository,
                                           config.get_address(),
                                           config.get_port())
        reporters.append(g4basic_reporter)
        self._g4basic_reporter = g4basic_reporter

        return reporters

    def _aux_props(self):
        # hide super()'s ModelConfigBase.THERMAL_SENSE_INTERVAL
        return []

    def _make_reporters(self, config):
        # hide super()'s CpuTempReporter
        reporters = []
        return reporters

#
# End of File
#
