# server.py
import socket
import pickle

# Azure IoT
import asyncio
import json
from azure.iot.device import Message, MethodResponse
from azure.iot.device.aio import IoTHubDeviceClient
from azure.iot.device.aio import ProvisioningDeviceClient
from azure.iot.device.exceptions import CredentialError

ip_address = '192.168.1.20'
port = 7010
buffer_size = 4092

async def main():
    # Azure IoT
    endpoint = "global.azure-devices-provisioning.net"
    deviceid = "test2"
    id_scope = "0ne003D62E1"
    devicekey = "SCWyPo138dS8gbkt9Q1bx5hmLp81mSR2v97CcuddFEg="

    provisioning_device_client = ProvisioningDeviceClient.create_from_symmetric_key(
        provisioning_host=endpoint,
        registration_id=deviceid,
        id_scope=id_scope,
        symmetric_key=devicekey
    )

    try:
        registration_result = await provisioning_device_client.register()
        if registration_result.status != "assigned":
            print("Could not provision device.")
            return ErrorCode.AuthenticationFailed
        else:
            print("Device was assigned")
    except:
        print("Connection error.")
        return ErrorCode.ConnectionFailed
    registration_state = registration_result.registration_state
    print(registration_state.assigned_hub)
    print(registration_state.device_id)
    device_client = IoTHubDeviceClient.create_from_symmetric_key(
        symmetric_key=devicekey,
        hostname=registration_state.assigned_hub,
        device_id=registration_state.device_id,
        #product_info=model_id,
        #connection_retry=False
    )
    await device_client.connect()
    # Azure IoT

    with socket.socket(socket.AF_INET, socket.SOCK_STREAM) as s:
        s.bind((ip_address, port))
        s.listen(5)
        while True:
            conn, addr = s.accept()
            data = conn.recv(buffer_size)
            print('data-> {}, addr->{}'.format(data, addr))
            d = pickle.loads(data)
            print('object->', d)
            conn.sendall(b'I received the data correctly.')

            msg = Message(json.dumps(d))
            msg.content_encoding = "utf-8"
            msg.content_type = "application/json"
            await asyncio.wait_for(device_client.send_message(msg), timeout=10)

if __name__ == '__main__':
    asyncio.run(main())
