import asyncio
import datetime
from datetime import datetime
from enum import Enum
from enum import IntEnum
from time import time
from time import localtime, strftime

from modules.lib.report import Report
from modules.lib.active_reporter import ActiveReporter
from modules.azure.report_repository import AzureReportRepository

# G4
import socket
import select
import pickle
ip_address = '192.168.1.20'
#ip_address = '127.0.0.1'
port = 7010
buffer_size = 4092

class G4State(IntEnum):
    WAIT_DATA    = 1,
    READY_REPORT = 2 

class G4Reporter(ActiveReporter):
    TZ_INFO = strftime("%z", localtime())

    def __init__(self, report_queue, report_repository):
        super().__init__(report_queue, report_repository)
        self._curr_state     = G4State.WAIT_DATA
        self._rcvdata        = ''
        """
        self._measured_val   = 0.0
        self._measure_time   = ''
        self._item_code      = ''
        """

    def request_stop(self):
        super().request_stop()

    def _before_loop(self):
        print("before loop")
        # blocking
        self.socket = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        self.socket.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
        self.socket.bind((ip_address, port))
        self.socket.listen(5)

        # non-blocking
        """
        self.socket = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        self.socket.setblocking(False)
        self.socket.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
        self.socket.bind((ip_address, port))
        self.socket.listen(5)
        """

    def _after_loop(self):
        print("after loop")

    def _handle_state(self):
        """"
        conn, addr = self.socket.accept()
        print(conn)
        print(addr)
        data = conn.recv(1024)

        report = Report.report_now(
                     'measurement',
                     type='item_weight',
                     key='tl-280',
                     value={
                         'item': "cookie",
                         'weight': 30,
                         'weighed_time': 45},
                     unit='g'
                                                                                                                                                                                    )
        self._report_queue.push(report)
        conn.close()
        """
        """
        print(self.conn)
        data = self.conn.recv(1024)
        print(data)
        #print("_handle_state")
        """

        """ select
        r, _, _ = select.select([self.socket.fileno()], [], [], 1)
        if len(r) != 0:
            conn, addr = self.socket.accept()
            data = conn.recv(1024)
            print(data)
            
            report = Report.report_now(
                        'measurement',
                        type='item_weight',
                        key='tl-280',
                        value={
                            'item': "cookie",
                            'weight': 30,
                            'weighed_time': 45},
                        unit='g'
                     )
            self._report_queue.push(report)
            conn.close() 
        """
        if G4State.WAIT_DATA == self._curr_state:
            self._handle_wait_measurement()
        elif G4State.READY_REPORT == self._curr_state:
            self._handle_ready_report()

    def _do_transit_action(self, next_state):
        print("transient to the state ", next_state)

    def _handle_wait_measurement(self):
        r, _, _ = select.select([self.socket.fileno()], [], [], 1)
        if len(r) != 0:
            conn, addr = self.socket.accept()
            data = conn.recv(buffer_size)
            self._rcvdata = pickle.loads(data) 
            print(self._rcvdata)
            conn.close()
            self._transit_state(G4State.READY_REPORT)
        # It should be add error handling

    def _handle_ready_report(self):
        # make report and enqueue it
        report = Report.report_now(
            'measurement',
            type=AzureReportRepository.BAG_OF_REPORT,
            key='',
            value=self._rcvdata,
            #value={"detect_count": 4, "AIEvent": {"item": "cookie", "count": 5}},
            unit=''
        )
        self._report_queue.push(report)

        # update status
        self._transit_state(G4State.WAIT_DATA)

#
# End of File
#

